#ifndef BNETPROTO_HH
#define BNETPROTO_HH

#define BNET_HEAD_LEN 4
#define BNET_GAMEINFO_LEN 32

#define BNET_PT_GAMEINFO	0x09ff
#define BNET_PT_HELLO		0x50ff
#define BNET_PT_MESSAGE 	0x0fff
#define BNET_PT_NEWGAME 	0x1cff
#define BNET_PT_CHATCMD 	0x0eff

struct _bnet_packet_head
{
	uint16_t type, len;
} __attribute__((packed));

#define bnet_packet_head(p) ((struct _bnet_packet_head *)(p))

struct _bnet_gameinfo_struct
{
	uint32_t ul1;
	uint16_t us1[3], port;
	uint32_t ip;
	uint32_t ul2[4];
} __attribute__((packed));

typedef uint32_t _bnet_server_challenge[2];

struct _bnet_udp_packet__player
{
	uint32_t id;
	uint16_t unknown1;
	uint16_t len;

	int16_t w1[4];		// w1[2] = 0x600
	uint32_t d1[4];
	uint16_t w2[2];
	uint16_t addr_type;	// addr_type = 2	// sockaddr_in (16B)
	uint16_t port;
	uint32_t ip;
	uint32_t pad[2];	// pad[0] = pad[1] = 0
	char name[0];
} __attribute__((packed));

#endif /* !BNETPROTO_HH */
